#========================================================
#
# DMXIS CLIPBOARD COPY by Kalle Paakkonen - 4 Sep 2018
#                      ENJOY!
#
# Copy all values of selected channel(s) to clipboard
#========================================================

#========================================================
# Edit the following file path according to your system.
#
# WARNING: Make sure not to use any existing file because
# DMXIS would overwite it.
#========================================================
clipboardfile = "/tmp/dmxis_clipboard"


import marshal
ns = GetNumSelCh()

if not ns:
    Message("Select some channels first!")
    raise ValueError("No Channels Selected")

objList = []

for j in range(ns):
    i = GetSelCh(j)
    obj = (i, GetChVal(i), GetStLevel(i), GetStBand(i),
           GetStAttack(i), GetStRelease(i), GetStDir(i),
           GetOscType(i), GetOscAmount(i), GetOscChase(i),
           GetOscSpeed(i), GetOscShape(i),
           GetChInvert(i), GetChEnabled(i))
    objList.append(obj)

file = None
try:
    file = open(clipboardfile, 'w')
except Exception as e:
    Message("Could not write the clipboard file. Check the macro configuration.")
    raise e

data = marshal.dumps(objList)
file.write(data)
file.close()
print("Copied " + str(len(objList)) + " channels")
